#!/usr/bin/env perl
#####################################################
# CVSROOT Management Tool
# Author     : Hojin Choi <pynoos@users.kldp.net>
# Last update: 2004/2/12
# $Revision: 1.1 $
#####################################################

local $file_name_permit;

sub filenamechk_preprocess(@)
{
	$file_name_permit = "file_name_permit";
	return 1;
}

sub print_permitted_rules()
{
	my %tplhash;

	my( $path, $confname, $showtitle ) = @_;
	print "$showtitle: Check $confname\n";
	foreach( @{$conf_array{$file_name_permit}} )
	{
		next unless /((.{1})([^\2]*)\2)(.*)\s*$/;
		my( $p, $e ) = ($3, $4 );
		my( $pdesc ) = $1;
		$e =~ s/^\s*(.*)/\1/;
		$rule_desc .= sprintf( "%-20s : %1s\n", "/$p/", $e);
	}
	$tplhash{'RULE_DESC'} = $rule_desc;
	print replace_template( $tpl{'FILE_NAME_PERMIT'}, %tplhash );
}

sub filenamechk_foreach($)
{
	my $file = shift;
	unless( -f $file )
	{
		print $log "There is no such a file.\n";
		return;
	}

	print $log "File naming-rule check: file [$file]\n";

	unless( $conf{$file_name_permit} )
	{
		print $log "There is no rule for file_name_permit\n";
		return;
	}

	if( $file eq $CVSADMIN )
	{
		return;
	}

	my $filenamechk_rule = get_matched_pattern( $file, $file_name_permit, "cvsnotify-filenamechk" );
	unless( $filenamechk_rule )
	{
		print "$file does not match with any permitted file naming rules.\n";
		print_permitted_rules();
		exit 1;
	}
	print "$file: $filenamechk_rule\n";
	print $log "File naming rule permits.\n";
	return;
}

sub filenamechk_postprocess(@)
{
	return 1;
}

# End of script.
1
